'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.event = event;
exports.anyOf = anyOf;

var _observable = require('./observable');

var _observable2 = _interopRequireDefault(_observable);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function event() {
    var observable = new _observable2.default();

    var result = function result() {
        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        observable.notify({ event: result, payload: args });
    };

    result[Symbol.observable] = function () {
        return observable;
    };

    result.map = function (mapFunc) {
        return observable.map(mapFunc);
    };

    result.as = function (value) {
        return observable.map(function () {
            return value;
        });
    };

    result.take = function () {
        return observable.first().map(function (_ref) {
            var payload = _ref.payload;
            return payload;
        }).toPromise();
    };

    return result;
}

function anyOf() {
    for (var _len2 = arguments.length, events = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        events[_key2] = arguments[_key2];
    }

    return Promise.race(events.map(function (x) {
        return x[Symbol.observable]().toPromise();
    }));
}