'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var SubscriptionObserver = function () {
    function SubscriptionObserver(source, observer) {
        _classCallCheck(this, SubscriptionObserver);

        this.source = source;
        this.observer = observer;
    }

    _createClass(SubscriptionObserver, [{
        key: 'unsubscribe',
        value: function unsubscribe() {
            this.source.unsubscribe(this);
        }
    }, {
        key: 'next',
        value: function next() {
            if (typeof this.observer.next === 'function') {
                var _observer;

                (_observer = this.observer).next.apply(_observer, arguments);
            }
        }
    }, {
        key: 'error',
        value: function error(errorValue) {
            if (typeof this.observer.error === 'function') {
                this.observer.error(errorValue);
            }
        }
    }, {
        key: 'complete',
        value: function complete(completeValue) {
            if (typeof this.observer.complete === 'function') {
                this.observer.complete(completeValue);
            }
        }
    }]);

    return SubscriptionObserver;
}();

var SelfMadeActionsObservable = function () {
    function SelfMadeActionsObservable() {
        _classCallCheck(this, SelfMadeActionsObservable);

        this.subscriptions = new Set();
    }

    _createClass(SelfMadeActionsObservable, [{
        key: 'notify',
        value: function notify() {
            if (this.subscriptions) {
                var _iteratorNormalCompletion = true;
                var _didIteratorError = false;
                var _iteratorError = undefined;

                try {
                    for (var _iterator = this.subscriptions[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                        var subscription = _step.value;

                        subscription.next.apply(subscription, arguments);
                    }
                } catch (err) {
                    _didIteratorError = true;
                    _iteratorError = err;
                } finally {
                    try {
                        if (!_iteratorNormalCompletion && _iterator.return) {
                            _iterator.return();
                        }
                    } finally {
                        if (_didIteratorError) {
                            throw _iteratorError;
                        }
                    }
                }
            }
        }
    }, {
        key: 'close',
        value: function close(result) {
            if (this.subscriptions) {
                var _iteratorNormalCompletion2 = true;
                var _didIteratorError2 = false;
                var _iteratorError2 = undefined;

                try {
                    for (var _iterator2 = this.subscriptions[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
                        var subscription = _step2.value;

                        subscription.complete(result);
                    }
                } catch (err) {
                    _didIteratorError2 = true;
                    _iteratorError2 = err;
                } finally {
                    try {
                        if (!_iteratorNormalCompletion2 && _iterator2.return) {
                            _iterator2.return();
                        }
                    } finally {
                        if (_didIteratorError2) {
                            throw _iteratorError2;
                        }
                    }
                }

                this.subscriptions = undefined;
            }
        }
    }, {
        key: 'throw',
        value: function _throw(error) {
            if (this.subscriptions) {
                var _iteratorNormalCompletion3 = true;
                var _didIteratorError3 = false;
                var _iteratorError3 = undefined;

                try {
                    for (var _iterator3 = this.subscriptions[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
                        var subscription = _step3.value;

                        subscription.error(error);
                    }
                } catch (err) {
                    _didIteratorError3 = true;
                    _iteratorError3 = err;
                } finally {
                    try {
                        if (!_iteratorNormalCompletion3 && _iterator3.return) {
                            _iterator3.return();
                        }
                    } finally {
                        if (_didIteratorError3) {
                            throw _iteratorError3;
                        }
                    }
                }

                this.subscriptions = undefined;
            }
        }
    }, {
        key: 'unsubscribe',
        value: function unsubscribe(subscription) {
            if (this.subscriptions) {
                this.subscriptions.delete(subscription);
            }
        }
    }, {
        key: 'subscribe',
        value: function subscribe(observer) {
            if (this.subscriptions) {
                var subscription = new SubscriptionObserver(this, observer);
                this.subscriptions.add(subscription);
                return subscription;
            }
            return undefined;
        }
    }, {
        key: Symbol.observable,
        value: function value() {
            return this;
        }
    }, {
        key: 'toPromise',
        value: function toPromise() {
            var _this = this;

            return new Promise(function (resolve, reject) {
                var subscription = _this.subscribe({
                    next: function next() {
                        subscription.unsubscribe();
                        resolve.apply(undefined, arguments);
                    },
                    complete: function complete() {
                        reject('Observable completed without matched elements');
                    },
                    error: function error() {
                        reject.apply(undefined, arguments);
                    }
                });
            });
        }
    }, {
        key: 'map',
        value: function map(mapFunc) {
            var resultObservable = new SelfMadeActionsObservable();
            this.subscribe({
                next: function next() {
                    resultObservable.notify(mapFunc.apply(undefined, arguments));
                },
                complete: function complete() {
                    resultObservable.close.apply(resultObservable, arguments);
                },
                error: function error() {
                    resultObservable.throw.apply(resultObservable, arguments);
                }
            });
            return resultObservable;
        }
    }, {
        key: 'first',
        value: function first() {
            var condition = arguments.length <= 0 || arguments[0] === undefined ? function () {
                return true;
            } : arguments[0];

            var resultObservable = new SelfMadeActionsObservable();

            var subscription = this.subscribe({
                next: function next() {
                    if (condition.apply(undefined, arguments)) {
                        subscription.unsubscribe();
                        resultObservable.notify.apply(resultObservable, arguments);
                    }
                },
                complete: function complete() {
                    resultObservable.throw('Observable completed without matched elements');
                },
                error: function error() {
                    resultObservable.throw.apply(resultObservable, arguments);
                }
            });
            return resultObservable;
        }
    }]);

    return SelfMadeActionsObservable;
}();

exports.default = SelfMadeActionsObservable;